// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from delphi_esr_msgs:msg/EsrStatus1.idl
// generated code does not contain a copyright notice
#include "delphi_esr_msgs/msg/detail/esr_status1__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `canmsg`
#include "rosidl_runtime_c/string_functions.h"

bool
delphi_esr_msgs__msg__EsrStatus1__init(delphi_esr_msgs__msg__EsrStatus1 * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    delphi_esr_msgs__msg__EsrStatus1__fini(msg);
    return false;
  }
  // canmsg
  if (!rosidl_runtime_c__String__init(&msg->canmsg)) {
    delphi_esr_msgs__msg__EsrStatus1__fini(msg);
    return false;
  }
  // time_stamp
  // rolling_count
  // comm_error
  // curvature
  // scan_id
  // yaw_rate
  // vehicle_speed_calc
  return true;
}

void
delphi_esr_msgs__msg__EsrStatus1__fini(delphi_esr_msgs__msg__EsrStatus1 * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // canmsg
  rosidl_runtime_c__String__fini(&msg->canmsg);
  // time_stamp
  // rolling_count
  // comm_error
  // curvature
  // scan_id
  // yaw_rate
  // vehicle_speed_calc
}

bool
delphi_esr_msgs__msg__EsrStatus1__are_equal(const delphi_esr_msgs__msg__EsrStatus1 * lhs, const delphi_esr_msgs__msg__EsrStatus1 * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // canmsg
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->canmsg), &(rhs->canmsg)))
  {
    return false;
  }
  // time_stamp
  if (lhs->time_stamp != rhs->time_stamp) {
    return false;
  }
  // rolling_count
  if (lhs->rolling_count != rhs->rolling_count) {
    return false;
  }
  // comm_error
  if (lhs->comm_error != rhs->comm_error) {
    return false;
  }
  // curvature
  if (lhs->curvature != rhs->curvature) {
    return false;
  }
  // scan_id
  if (lhs->scan_id != rhs->scan_id) {
    return false;
  }
  // yaw_rate
  if (lhs->yaw_rate != rhs->yaw_rate) {
    return false;
  }
  // vehicle_speed_calc
  if (lhs->vehicle_speed_calc != rhs->vehicle_speed_calc) {
    return false;
  }
  return true;
}

bool
delphi_esr_msgs__msg__EsrStatus1__copy(
  const delphi_esr_msgs__msg__EsrStatus1 * input,
  delphi_esr_msgs__msg__EsrStatus1 * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // canmsg
  if (!rosidl_runtime_c__String__copy(
      &(input->canmsg), &(output->canmsg)))
  {
    return false;
  }
  // time_stamp
  output->time_stamp = input->time_stamp;
  // rolling_count
  output->rolling_count = input->rolling_count;
  // comm_error
  output->comm_error = input->comm_error;
  // curvature
  output->curvature = input->curvature;
  // scan_id
  output->scan_id = input->scan_id;
  // yaw_rate
  output->yaw_rate = input->yaw_rate;
  // vehicle_speed_calc
  output->vehicle_speed_calc = input->vehicle_speed_calc;
  return true;
}

delphi_esr_msgs__msg__EsrStatus1 *
delphi_esr_msgs__msg__EsrStatus1__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  delphi_esr_msgs__msg__EsrStatus1 * msg = (delphi_esr_msgs__msg__EsrStatus1 *)allocator.allocate(sizeof(delphi_esr_msgs__msg__EsrStatus1), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(delphi_esr_msgs__msg__EsrStatus1));
  bool success = delphi_esr_msgs__msg__EsrStatus1__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
delphi_esr_msgs__msg__EsrStatus1__destroy(delphi_esr_msgs__msg__EsrStatus1 * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    delphi_esr_msgs__msg__EsrStatus1__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
delphi_esr_msgs__msg__EsrStatus1__Sequence__init(delphi_esr_msgs__msg__EsrStatus1__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  delphi_esr_msgs__msg__EsrStatus1 * data = NULL;

  if (size) {
    data = (delphi_esr_msgs__msg__EsrStatus1 *)allocator.zero_allocate(size, sizeof(delphi_esr_msgs__msg__EsrStatus1), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = delphi_esr_msgs__msg__EsrStatus1__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        delphi_esr_msgs__msg__EsrStatus1__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
delphi_esr_msgs__msg__EsrStatus1__Sequence__fini(delphi_esr_msgs__msg__EsrStatus1__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      delphi_esr_msgs__msg__EsrStatus1__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

delphi_esr_msgs__msg__EsrStatus1__Sequence *
delphi_esr_msgs__msg__EsrStatus1__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  delphi_esr_msgs__msg__EsrStatus1__Sequence * array = (delphi_esr_msgs__msg__EsrStatus1__Sequence *)allocator.allocate(sizeof(delphi_esr_msgs__msg__EsrStatus1__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = delphi_esr_msgs__msg__EsrStatus1__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
delphi_esr_msgs__msg__EsrStatus1__Sequence__destroy(delphi_esr_msgs__msg__EsrStatus1__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    delphi_esr_msgs__msg__EsrStatus1__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
delphi_esr_msgs__msg__EsrStatus1__Sequence__are_equal(const delphi_esr_msgs__msg__EsrStatus1__Sequence * lhs, const delphi_esr_msgs__msg__EsrStatus1__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!delphi_esr_msgs__msg__EsrStatus1__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
delphi_esr_msgs__msg__EsrStatus1__Sequence__copy(
  const delphi_esr_msgs__msg__EsrStatus1__Sequence * input,
  delphi_esr_msgs__msg__EsrStatus1__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(delphi_esr_msgs__msg__EsrStatus1);
    delphi_esr_msgs__msg__EsrStatus1 * data =
      (delphi_esr_msgs__msg__EsrStatus1 *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!delphi_esr_msgs__msg__EsrStatus1__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          delphi_esr_msgs__msg__EsrStatus1__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!delphi_esr_msgs__msg__EsrStatus1__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
