// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from delphi_esr_msgs:msg/EsrTrack.idl
// generated code does not contain a copyright notice
#include "delphi_esr_msgs/msg/detail/esr_track__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `canmsg`
#include "rosidl_runtime_c/string_functions.h"

bool
delphi_esr_msgs__msg__EsrTrack__init(delphi_esr_msgs__msg__EsrTrack * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    delphi_esr_msgs__msg__EsrTrack__fini(msg);
    return false;
  }
  // canmsg
  if (!rosidl_runtime_c__String__init(&msg->canmsg)) {
    delphi_esr_msgs__msg__EsrTrack__fini(msg);
    return false;
  }
  // track_id
  // track_lat_rate
  // track_group_changed
  // track_status
  // track_angle
  // track_range
  // track_bridge_object
  // track_rolling_count
  // track_width
  // track_range_accel
  // track_med_range_mode
  // track_range_rate
  return true;
}

void
delphi_esr_msgs__msg__EsrTrack__fini(delphi_esr_msgs__msg__EsrTrack * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // canmsg
  rosidl_runtime_c__String__fini(&msg->canmsg);
  // track_id
  // track_lat_rate
  // track_group_changed
  // track_status
  // track_angle
  // track_range
  // track_bridge_object
  // track_rolling_count
  // track_width
  // track_range_accel
  // track_med_range_mode
  // track_range_rate
}

bool
delphi_esr_msgs__msg__EsrTrack__are_equal(const delphi_esr_msgs__msg__EsrTrack * lhs, const delphi_esr_msgs__msg__EsrTrack * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // canmsg
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->canmsg), &(rhs->canmsg)))
  {
    return false;
  }
  // track_id
  if (lhs->track_id != rhs->track_id) {
    return false;
  }
  // track_lat_rate
  if (lhs->track_lat_rate != rhs->track_lat_rate) {
    return false;
  }
  // track_group_changed
  if (lhs->track_group_changed != rhs->track_group_changed) {
    return false;
  }
  // track_status
  if (lhs->track_status != rhs->track_status) {
    return false;
  }
  // track_angle
  if (lhs->track_angle != rhs->track_angle) {
    return false;
  }
  // track_range
  if (lhs->track_range != rhs->track_range) {
    return false;
  }
  // track_bridge_object
  if (lhs->track_bridge_object != rhs->track_bridge_object) {
    return false;
  }
  // track_rolling_count
  if (lhs->track_rolling_count != rhs->track_rolling_count) {
    return false;
  }
  // track_width
  if (lhs->track_width != rhs->track_width) {
    return false;
  }
  // track_range_accel
  if (lhs->track_range_accel != rhs->track_range_accel) {
    return false;
  }
  // track_med_range_mode
  if (lhs->track_med_range_mode != rhs->track_med_range_mode) {
    return false;
  }
  // track_range_rate
  if (lhs->track_range_rate != rhs->track_range_rate) {
    return false;
  }
  return true;
}

bool
delphi_esr_msgs__msg__EsrTrack__copy(
  const delphi_esr_msgs__msg__EsrTrack * input,
  delphi_esr_msgs__msg__EsrTrack * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // canmsg
  if (!rosidl_runtime_c__String__copy(
      &(input->canmsg), &(output->canmsg)))
  {
    return false;
  }
  // track_id
  output->track_id = input->track_id;
  // track_lat_rate
  output->track_lat_rate = input->track_lat_rate;
  // track_group_changed
  output->track_group_changed = input->track_group_changed;
  // track_status
  output->track_status = input->track_status;
  // track_angle
  output->track_angle = input->track_angle;
  // track_range
  output->track_range = input->track_range;
  // track_bridge_object
  output->track_bridge_object = input->track_bridge_object;
  // track_rolling_count
  output->track_rolling_count = input->track_rolling_count;
  // track_width
  output->track_width = input->track_width;
  // track_range_accel
  output->track_range_accel = input->track_range_accel;
  // track_med_range_mode
  output->track_med_range_mode = input->track_med_range_mode;
  // track_range_rate
  output->track_range_rate = input->track_range_rate;
  return true;
}

delphi_esr_msgs__msg__EsrTrack *
delphi_esr_msgs__msg__EsrTrack__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  delphi_esr_msgs__msg__EsrTrack * msg = (delphi_esr_msgs__msg__EsrTrack *)allocator.allocate(sizeof(delphi_esr_msgs__msg__EsrTrack), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(delphi_esr_msgs__msg__EsrTrack));
  bool success = delphi_esr_msgs__msg__EsrTrack__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
delphi_esr_msgs__msg__EsrTrack__destroy(delphi_esr_msgs__msg__EsrTrack * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    delphi_esr_msgs__msg__EsrTrack__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
delphi_esr_msgs__msg__EsrTrack__Sequence__init(delphi_esr_msgs__msg__EsrTrack__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  delphi_esr_msgs__msg__EsrTrack * data = NULL;

  if (size) {
    data = (delphi_esr_msgs__msg__EsrTrack *)allocator.zero_allocate(size, sizeof(delphi_esr_msgs__msg__EsrTrack), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = delphi_esr_msgs__msg__EsrTrack__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        delphi_esr_msgs__msg__EsrTrack__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
delphi_esr_msgs__msg__EsrTrack__Sequence__fini(delphi_esr_msgs__msg__EsrTrack__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      delphi_esr_msgs__msg__EsrTrack__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

delphi_esr_msgs__msg__EsrTrack__Sequence *
delphi_esr_msgs__msg__EsrTrack__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  delphi_esr_msgs__msg__EsrTrack__Sequence * array = (delphi_esr_msgs__msg__EsrTrack__Sequence *)allocator.allocate(sizeof(delphi_esr_msgs__msg__EsrTrack__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = delphi_esr_msgs__msg__EsrTrack__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
delphi_esr_msgs__msg__EsrTrack__Sequence__destroy(delphi_esr_msgs__msg__EsrTrack__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    delphi_esr_msgs__msg__EsrTrack__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
delphi_esr_msgs__msg__EsrTrack__Sequence__are_equal(const delphi_esr_msgs__msg__EsrTrack__Sequence * lhs, const delphi_esr_msgs__msg__EsrTrack__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!delphi_esr_msgs__msg__EsrTrack__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
delphi_esr_msgs__msg__EsrTrack__Sequence__copy(
  const delphi_esr_msgs__msg__EsrTrack__Sequence * input,
  delphi_esr_msgs__msg__EsrTrack__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(delphi_esr_msgs__msg__EsrTrack);
    delphi_esr_msgs__msg__EsrTrack * data =
      (delphi_esr_msgs__msg__EsrTrack *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!delphi_esr_msgs__msg__EsrTrack__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          delphi_esr_msgs__msg__EsrTrack__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!delphi_esr_msgs__msg__EsrTrack__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
